import 'dart:html';
import 'dart:js';
import 'dart:math';

void main() {
  querySelector("#sample_text_id")
      ..text = "Click me!"
      ..onClick.listen(reverseText);
  
  querySelector("#text").addEventListener("mouseenter", changeColor);
  querySelector("#text").addEventListener("mouseout", resetColor);
}

void reverseText(MouseEvent event) {
  var text = querySelector("#sample_text_id").text;
  var buffer = new StringBuffer();
  for (int i = text.length - 1; i >= 0; i--) {
    buffer.write(text[i]);
  }
  querySelector("#sample_text_id").text = buffer.toString();
}

void changeColor(MouseEvent event) {
  var txt = querySelector("#text");
  var ran1 = new Random().nextInt(255).toString(),
      ran2 = new Random().nextInt(255).toString(),
      ran3 = new Random().nextInt(255).toString();
  txt.style.color = "rgb(" + ran1 + ", " + ran2 + ", " + ran3 + ")";
  txt.style.transition = "color .8s ease-in-out";
//  txt.style.webkitTransition = "color 1s ease-in-out";
//  alert(ran1.toString() + ", " + ran2.toString() + ", " + ran3.toString());
}

void resetColor(MouseEvent event) {
  var txt = querySelector("#text");
  txt.style.color = "rgb(0, 0, 0)";
  txt.style.transition = "color .5s ease-in-out";
}

void alert(_msg) {
  context.callMethod("alert", ["$_msg"]);
}
